/*VERTEX_PROGRAM*/

#include Layout.sp
#include StdList.sp

/*FRAGMENT_PROGRAM*/

in vec2 TexCoord;

uniform sampler2D Texture0;

uniform vec4 OverlayColor;

out vec4 out_FragColor;

void main()
{
	// for 256x256 texture
	float Pixel = 1.0 / 256.0;

	// hack a little, remove 1 pixel from each side 
	vec2 X = vec2( 1.0 - 2.0 * Pixel );

   vec4 Color = texture( Texture0, TexCoord * X + vec2(Pixel) );

	// edges antialiasing
	float Y1 = 0.01;
	float Y2 = 0.99;

	float X1 = 0.01;
	float X2 = 0.99;

	float y = TexCoord.y;
	float x = TexCoord.x;

	Color.a *= ( y < Y1 ) ? (y / Y1) : 1.0;
	Color.a *= ( y > Y2 ) ? ( ( 1.0 - y ) / ( 1.0 - Y2 ) ) : 1.0;

	Color.a *= ( x < X1 ) ? (x / X1) : 1.0;
	Color.a *= ( x > X2 ) ? ( ( 1.0 - x ) / ( 1.0 - X2 ) ) : 1.0;

   out_FragColor = Color; // * OverlayColor;
}
