/*VERTEX_PROGRAM*/

#include Layout.sp
#include StdList.sp

/*FRAGMENT_PROGRAM*/

in vec2 TexCoord;

uniform sampler2D Texture0;
uniform sampler2D Texture1;

uniform vec4 OverlayColor;

out vec4 out_FragColor;

void main()
{
	vec4 Color = texture( Texture0, TexCoord );
	vec4 Mask  = texture(Texture1, vec2(TexCoord.x, 1.0 - TexCoord.y) );

	Color.w = Mask.r;

	// edges antialiasing
	float Y1 = 0.01;
	float Y2 = 0.99;

	float X1 = 0.01;
	float X2 = 0.99;

	float y = TexCoord.y;
	float x = TexCoord.x;

	Color.a *= ( y < Y1 ) ? (y / Y1) : 1.0;
	Color.a *= ( y > Y2 ) ? ( ( 1.0 - y ) / ( 1.0 - Y2 ) ) : 1.0;

	Color.a *= ( x < X1 ) ? (x / X1) : 1.0;
	Color.a *= ( x > X2 ) ? ( ( 1.0 - x ) / ( 1.0 - X2 ) ) : 1.0;

   out_FragColor = Color * OverlayColor;
}
