/*VERTEX_PROGRAM*/

#include Layout.sp

in vec4 in_Vertex;
in vec4 in_TexCoord;

out vec2 v_TexCoord;

uniform vec4 u_DiffuseColor;

void main()
{
	// check out http://www.geeks3d.com/20140807/billboarding-vertex-shader-glsl/
	vec3 X = vec3(in_ModelViewMatrix[0][0], in_ModelViewMatrix[1][0], in_ModelViewMatrix[2][0]);
	vec3 Y = vec3(in_ModelViewMatrix[0][1], in_ModelViewMatrix[1][1], in_ModelViewMatrix[2][1]);
  
	float SizeX = u_DiffuseColor.x;
	float SizeY = u_DiffuseColor.y;

	vec3 XOfs = ( 2.0 * (in_TexCoord.x-0.5) * SizeX ) * X;
	vec3 YOfs = ( 2.0 * (in_TexCoord.y-0.5) * SizeY ) * Y;

	vec3 Position = XOfs + YOfs;

	vec4 TransformedPos = in_ModelViewProjectionMatrix * vec4( Position, 1.0 );

	gl_Position = TransformedPos;

	// flip vertival
	v_TexCoord = vec2( in_TexCoord.x, 1.0 - in_TexCoord.y );
}

/*FRAGMENT_PROGRAM*/

#include Layout.sp

in vec2 v_TexCoord;

uniform sampler2D Texture1; // ambient map

out vec4 out_FragColor;
                                              
void main()
{
	vec4 Color = texture( Texture1, v_TexCoord );

	out_FragColor = Color;
}
