/*VERTEX_PROGRAM*/

#include Layout.sp

in vec4 in_Vertex;
in vec4 in_TexCoord;
in vec3 in_Normal;
in vec4 in_Color;

out vec2 v_TexCoord;
out vec4 v_Color;

#include MaterialSystem/ShaderLib/Uniforms_Vertex.sp

void main()
{
   vec4 Position = in_Vertex;

   gl_Position = in_ModelViewProjectionMatrix * Position;

   v_TexCoord = in_TexCoord.xy;
	v_Color = in_Color;
}

/*FRAGMENT_PROGRAM*/

#include Layout.sp

in vec2 v_TexCoord;
in vec4 v_Color;

out vec4 out_FragColor;

#include MaterialSystem/ShaderLib/Uniforms_Fragment.sp

void main()
{
	vec4 FinalColor = v_Color;

	out_FragColor = FinalColor;
}
