/** XYZ <-> RGB conversion */

const mat3 RGBtoXYZ = mat3(0.5893, 0.1789, 0.1831, 0.2904, 0.6051, 0.1045, 0.0000, 0.0684, 1.0202);
const vec3 XYZwpNL = RGBtoXYZ * vec3(1.0,1.0,1.0);
const vec3 XYZwp = vec3(XYZwpNL.r*(100./XYZwpNL.g),100.,XYZwpNL.b*(100./XYZwpNL.g));

float fLAB(in float t) { return (t>0.008856)?pow(t,1./3.):7.787*t+16./116.; }

vec3 XYZtoLAB(vec3 xyz)
{
	vec3 fLABres = vec3(fLAB(xyz.r/XYZwp.r),fLAB(xyz.g/XYZwp.g),fLAB(xyz.b/XYZwp.b));

	return vec3(116.*fLABres.g-16., 500.*(fLABres.r-fLABres.g), 200.*(fLABres.g-fLABres.b));
}

float distanceLAB(vec3 c1, vec3 c2) { vec3 c12 = c1 - c2; return sqrt(dot(c12,c12)); }
float distanceLABFromRGBandRef(vec3 test, vec3 ref) { return distanceLAB(XYZtoLAB(RGBtoXYZ * test),ref); }
float distanceSqRGB(vec3 col1, vec3 col2) { return dot(col2-col1, col2-col1); }

// Renvoie une couleur à partir d'une sorte d'entier en flotant
// 0 : black
// 1 : rouge
// 2 : vert
// 3 : bleu
// 4+ : blanc
vec4 convertFloattoRGB(float curseur) {
	if (curseur<0.05) return vec4(0.,0.,0.,1.0);
	if (curseur<1.1) return vec4(1.,0.,0.,1.);
	if (curseur<2.1) return vec4(0.,1.,0.,1.);
	if (curseur<3.1) return vec4(0.,0.,1.,1.);
	else return vec4(1.);
}
