/** */

#include Layout.sp

in vec4 in_Vertex;
in vec4 in_TexCoord;

out vec4 owncoordinates;
out vec4 gl_TexCoord[4];
uniform vec4 coeff_image;

/* Renvoie les 8-connexites suivantes ...

[1].zw	|	[1].xy	| [0].zw
[2].xy	|	X	| [0].xy
[2].zw	|	[3].xy	| [3].zw

*/
void main()
{
	float X = in_TexCoord.x;
	float Y = in_TexCoord.y;

	// Recuperation de la position de la camera
	owncoordinates = in_TexCoord;

	gl_TexCoord[0] = vec4(X + coeff_image.x, Y, X + coeff_image.x, Y + coeff_image.y);
	gl_TexCoord[1] = vec4(X, Y + coeff_image.y, X - coeff_image.x, Y + coeff_image.y);
	gl_TexCoord[2] = vec4(X - coeff_image.x, Y, X - coeff_image.x, Y - coeff_image.y);
	gl_TexCoord[3] = vec4(X, Y - coeff_image.y, X + coeff_image.x, Y - coeff_image.y);

	gl_Position = in_ModelViewProjectionMatrix * in_Vertex;
}
