/** */

#include Layout.sp

out vec4 out_FragColor;

uniform sampler2D tex_length_prec;
// TEXTURE tex_length_prec CONTAINS (r,g,b,a): left/right/up/down distance (number of pixels)

in vec4 owncoordinates;
uniform float threshold;
uniform vec4 coeff_image;
const vec4 one_step_up = vec4(1./255.0);
const vec4 one_pixel = vec4(255.0);

void main() {
	vec4 current_lengths = texture2D(tex_length_prec,owncoordinates.st);
	vec4 current_delta;
	vec2 tex_coord;
	float one_delta;

	current_delta = current_lengths;
	current_delta *= coeff_image.zzww;

	// LEFT
	if (current_lengths.r >= threshold) {
		tex_coord = owncoordinates.st - vec2(current_delta.r,0.);
		for (int k = 0; k < 3; ++k) {
			one_delta = texture2D(tex_length_prec, tex_coord).r;
			current_lengths.r += one_delta;
			tex_coord.x -= one_delta * coeff_image.z;
		}
	}

	// RIGHT
	if (current_lengths.g >= threshold) {
		tex_coord = owncoordinates.st + vec2(current_delta.g,0.);
		for (int k = 0; k < 3; ++k) {
			one_delta = texture2D(tex_length_prec, tex_coord).g;
			current_lengths.g += one_delta;
			tex_coord.x += one_delta * coeff_image.z;
		}
	}

	// TOP
	if (current_lengths.b >= threshold)
	{
		tex_coord = owncoordinates.st + vec2(0.,current_delta.b);
		for (int k = 0; k < 3; ++k) {
			one_delta = texture2D(tex_length_prec, tex_coord).b;
			current_lengths.b += one_delta;
			tex_coord.y += one_delta * coeff_image.w;
		}
	}

	// BOTTOM
	if (current_lengths.a >= threshold)
	{
		tex_coord = owncoordinates.st - vec2(0.,current_delta.a);
		for (int k = 0; k < 3; ++k) {
			one_delta = texture2D(tex_length_prec, tex_coord).a;
			current_lengths.a += one_delta;
			tex_coord.y -= one_delta * coeff_image.w;
		}
	}

	out_FragColor = current_lengths;
}
