/** */

#include Layout.sp

out vec4 out_FragColor;

uniform sampler2D Texture0; // basetex
// (r,g,b,a) : alpha with (up,down,left,right) pixel   // TODO: check left/right ! b and a can be erroneous
uniform sampler2D Texture1; // alpha

in vec4 owncoordinates;

uniform vec4 coeff_image;

void main() {
	vec4 Final = textureLod(Texture0, owncoordinates.xy, 0.0);
	vec4 Alpha = textureLod(Texture1, owncoordinates.xy, 0.0);

	// Up, Down, Right, Left
	float coef[4] = {Alpha.r, Alpha.g, Alpha.b, Alpha.a};
	vec2 coord[4] = {gl_TexCoord[0].zw, gl_TexCoord[1].zw, gl_TexCoord[0].xy, gl_TexCoord[1].xy};

	for(int i = 0 ; i < 4 ; i++)
		if (coef[0] > 0.)
			Final = mix(Final, textureLod(Texture0, coord[i], 0.0), coef[i]);

	out_FragColor = final_color;
}
