/** */

#include Layout.sp

uniform sampler2D basetex;
in vec4 owncoordinates;
uniform float disc_factor;

#include "colorXYZ.sp"

void main() {
	vec4 color_c = texture2D(basetex,owncoordinates.st);
	gl_FragData[0] = vec4(0.);
	gl_FragData[1] = vec4(0.);

	vec3 color_c_lab = XYZtoLAB(RGBtoXYZ * color_c.rgb);
	// Right border test
	vec3 color_compare_lab = XYZtoLAB(RGBtoXYZ * texture2D(basetex,gl_TexCoord[0].xy).rgb);
	if (distanceLAB(color_c_lab,color_compare_lab) > disc_factor) {
		gl_FragData[0].r = 1.;
		gl_FragData[1].ba = vec2(1./255.);
	}

	// Bottom border test
	color_compare_lab = XYZtoLAB(RGBtoXYZ * texture2D(basetex,gl_TexCoord[1].zw).rgb);
	if (distanceLAB(color_c_lab,color_compare_lab) > disc_factor) {
		gl_FragData[0].g = 1.;
		gl_FragData[1].rg = vec2(1./255.);
	}
}
