/** Merged Prepass and Prepass_Greyscale / Prepass_no_depth and Prepass_no_depth_Greyscale */

#include Layout.sp

out vec4 out_FragColor;

uniform sampler2D basetex;
#ifdef USE_DEPTH
uniform sampler2D depthtex;
#endif
uniform sampler1D nb_connex;

#include "colorXYZ.sp"
uniform sampler1D nb_connex_barre;

uniform vec4 coeff_image;
uniform vec4 col1;
uniform vec4 col2;
in vec4 gl_TexCoord[4];
in vec4 owncoordinates;
uniform float disc_factor;

uniform int UseBarre;

// nb_connex_barre (4)
const int Table_Barre[] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31};
// nb_connex (8)
const int Table_[] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31};

/// 8 items per integer
int GetTabValue(int idx)
{
	if( idx == ) return 4;

	int j = idx % 8;

	int Mask = (3 << j);

	if(UseBarre == 1)
		return ((Table_Barre[idx / 8] & Mask) >> j) & 3;
	else
		return ((Table_[idx / 8] & Mask) >> j) & 3;
}

void main() {
	vec4 res1,res2, color_diff;
	bvec4 b_res1,b_res2;
	vec4 a_res1,a_res2;
	vec4 ref = vec4(disc_factor);
	vec2 depth_comp;

	vec3 color_c = texture2D(basetex,owncoordinates.xy).rgb;
	vec3 color_ref_lab = XYZtoLAB(RGBtoXYZ * color_c);
	mat4 color_voisin_a, color_voisin_b;

	out_FragColor = vec4(color_c,1.);

	color_voisin_a[0] = vec4(texture2D(basetex,gl_TexCoord[0].xy).rgb,1.);
	color_voisin_a[1] = vec4(texture2D(basetex,gl_TexCoord[0].zw).rgb,1.);
	color_voisin_a[2] = vec4(texture2D(basetex,gl_TexCoord[1].xy).rgb,1.);
	color_voisin_a[3] = vec4(texture2D(basetex,gl_TexCoord[1].zw).rgb,1.);
	color_voisin_b[0] = vec4(texture2D(basetex,gl_TexCoord[2].xy).rgb,1.);
	color_voisin_b[1] = vec4(texture2D(basetex,gl_TexCoord[2].zw).rgb,1.);
	color_voisin_b[2] = vec4(texture2D(basetex,gl_TexCoord[3].xy).rgb,1.);
	color_voisin_b[3] = vec4(texture2D(basetex,gl_TexCoord[3].zw).rgb,1.);

	res1.x = distanceLABFromRGBandRef(color_voisin_a[0].rgb,color_ref_lab);
	res1.y = distanceLABFromRGBandRef(color_voisin_a[1].rgb,color_ref_lab);
	res1.z = distanceLABFromRGBandRef(color_voisin_a[2].rgb,color_ref_lab);
	res1.w = distanceLABFromRGBandRef(color_voisin_a[3].rgb,color_ref_lab);
	b_res1 = greaterThan(res1,ref);
	res1 = vec4(b_res1);
	color_diff = color_voisin_a*res1;
	a_res1 = vec4(not(b_res1));

	res2.x = distanceLABFromRGBandRef(color_voisin_b[0].rgb,color_ref_lab);
	res2.y = distanceLABFromRGBandRef(color_voisin_b[1].rgb,color_ref_lab);
	res2.z = distanceLABFromRGBandRef(color_voisin_b[2].rgb,color_ref_lab);
	res2.w = distanceLABFromRGBandRef(color_voisin_b[3].rgb,color_ref_lab);
	b_res2 = greaterThan(res2,ref);
	res2 = vec4(b_res2);
	color_diff += color_voisin_b*res2;
	a_res2 = vec4(not(b_res2));

	// CALCUL DE L'INDICE DANS LES TABLEAUX...
	res1.x = dot(res1,vec4(col1));
	res1.y = dot(res2,vec4(col2));
	res1.x = (res1.x+res1.y);

	a_res1.x = dot(a_res1,vec4(col1));
	a_res1.y = dot(a_res2,vec4(col2));
	a_res1.x = (a_res1.x+a_res1.y);

	color_diff.rgb /= color_diff.a;

	res1.y   = GetTabValue_(res1.x);
	a_res1.y = GetTabValue_(a_res1.x);

	if (res1.y >= 1.1) {
		if ((a_res1.y < 1.1) && (a_res1.y > 0.9)) {
#ifdef USE_DEPTH
			depth_comp.x = texture2D(depthtex,owncoordinates.xy).r;

			vec2 Coord;

			if (any(b_res1)) {
				if (any(b_res1.xy)) {
					Coord = b_res1.x ? gl_TexCoord[0].xy : gl_TexCoord[0].zw;
				} else {
					Coord = b_res1.z ? gl_TexCoord[1].xy : gl_TexCoord[1].zw;
				}
			}
			else {
				if (any(b_res2.xy)) {
					Coord = b_res2.x ? gl_TexCoord[2].xy : gl_TexCoord[2].zw;
				} else {
					Coord = b_res2.z ? gl_TexCoord[3].xy : gl_TexCoord[3].zw;
				}
			}

			depth_comp.y = texture2D(depthtex, Coord).r;

			out_FragColor = (depth_comp.x > depth_comp.y) ? vec4(0,0,1,1) : vec4(1);
#else // No depth
			out_FragColor = vec4(color_diff.rgb,1.);
#endif
		}
	}
}
