/*VERTEX_PROGRAM*/

#include Layout.sp

in vec4 in_Vertex;
in vec4 in_TexCoord;

out vec3 v_WorldPos;
out vec2 v_TexCoord;

void main()
{
   gl_Position = in_ModelViewProjectionMatrix * in_Vertex;
	
	v_WorldPos = ( in_ModelViewMatrix * in_Vertex ).xyz;
   v_TexCoord = vec2( in_TexCoord );
}


/*FRAGMENT_PROGRAM*/

uniform sampler2D Texture0;   // Scene color
uniform sampler2D Texture1;   // Scene depth
uniform sampler2D Texture2;   // SSAO

in vec2 v_TexCoord;

out vec4 out_FragColor;

void main()
{
	vec4  Color = texture( Texture0, v_TexCoord );
	float SSAO  = texture( Texture2, v_TexCoord ).x;

	vec3 C = Color.rgb * vec3( SSAO );

//	C = vec3( SSAO );
//	C = Color.rgb;

	out_FragColor = vec4( C, 1.0 );
}
