/*VERTEX_PROGRAM*/

#include Layout.sp

in vec4 in_Vertex;
in vec4 in_TexCoord;
in vec3 in_Normal;
in vec2 in_Bones;

out vec2 v_TexCoord;

#include MaterialSystem/ShaderLib/Uniforms_Vertex.sp

#if defined( SUPPORTED_VERTEX_TEXTURE_FETCH )
#include MaterialSystem/ShaderLib/QuaternionLib.sp
#include MaterialSystem/ShaderLib/Skinning.sp
#endif

void main()
{
#if defined( SUPPORTED_VERTEX_TEXTURE_FETCH )
   vec4 Position = ( u_KeyFrame.w == 1.0 ) ? SkinVertex() : in_Vertex;
#else
   vec4 Position = in_Vertex;
#endif

   gl_Position = in_ModelViewProjectionMatrix * Position;

	v_TexCoord = in_TexCoord.xy;
}

/*FRAGMENT_PROGRAM*/

#include Layout.sp

#include MaterialSystem/ShaderLib/Uniforms_Fragment.sp

in vec2 v_TexCoord;

out vec4 out_FragColor;

void main()
{
	// alpha test
	if ( u_MaterialAlphaTest.x > 0.0 )
	{
		if ( texture( Texture2, v_TexCoord ).a < u_MaterialAlphaTest.x ) discard;
	}

	out_FragColor = vec4( 0.0 );
}
