//
// Lighting computations
//

#if defined( USE_OPENGL_4 )
subroutine vec4 ShadingModelTerm( vec3 Normal, vec4 Kd, vec4 Ks );
subroutine uniform ShadingModelTerm u_ComputeShadingModelFunc;

subroutine(ShadingModelTerm)
vec4 ComputeNullLight( vec3 Normal, vec4 Diffuse, vec4 Specular )
{
	return vec4( 0.0 );
}
#endif

/*
float AttenuationForLight( float DistToLight )
{
	float Cutoff = u_LightAttenuation.y;

	// normalized light vector and distance to light surface
	float R = u_LightAttenuation.x;
	float D = max( DistToLight - R, 0.0 );

	float Denom = D/R + 1.0;
	float Attenuation = 1.0 / (Denom*Denom);

	// Scale and bias attenuation so that:
	//   attenuation == 0 at extent of max influence
	//   attenuation == 1 when d == 0

	return max( (Attenuation - Cutoff) / (1.0 - Cutoff), 0.0 );
}
*/

// http://framebunker.com/blog/lighting-2-attenuation/
float AttenuationForLight( float DistToLight )
{
	float R = u_LightAttenuation.x;
	float I = DistToLight / R;
	float Attenuation = max( 1.0 - I * I, 0.0 );

	return Attenuation;
}
