// Pack [0.0-1.0] float into a 8-bit RGBA color

vec4 Pack(float Value)
{
	const vec4 BitSh  = vec4( 256.0 * 256.0 * 256.0, 256.0 * 256.0, 256.0, 1.0);
	const vec4 BitMsk = vec4( 0.0, 1.0 / 256.0, 1.0 / 256.0, 1.0 / 256.0 );

	vec4 Comp = fract( Value * BitSh );

	Comp -= Comp.xxyz * BitMsk;

	return Comp;
}

float Unpack(vec4 Value)
{
	const vec4 BitShifts = vec4( 1.0 / (256.0 * 256.0 * 256.0), 1.0 / (256.0 * 256.0), 1.0 / 256.0, 1.0 );

	return dot( Value, BitShifts );
}
