//
// uniforms used to render scene graph
//

uniform sampler2D Texture0; // packed skeleton
uniform sampler2D Texture1; // ambient map
uniform sampler2D Texture2; // diffuse map
uniform sampler2D Texture3; // specular map
uniform sampler2D Texture4; // bump map
uniform sampler2D Texture5; // planar reflection map
uniform sampler2D Texture7; // shadow map
uniform sampler2D Texture8; // modulated texture
uniform samplerCube Texture9; // modulated cube map
uniform samplerCube Texture11; // shadow cube map

// shadow cascades split distances in camera space
uniform vec4 u_SplitDistances;

// all lighting is calculated in world space
uniform vec4 u_LightPosition;
uniform vec4 u_LightDirection;
uniform vec4 u_LightAmbientColor;
uniform vec4 u_LightColor;
// XYZW: radius, attenuation cutoff, UNUSED, light type
uniform vec4 u_LightAttenuation;
// XYZW: cos(inner angle), cos(outer angle), falloff, modulated
uniform vec4 u_LightSpotRange;
// XYZW: cast shadow, shadow coef, const bias, slope bias
uniform vec4 u_LightCastShadow;

uniform vec4 u_ReceiveShadow;

// XYZ: min steps, max steps, bump scale
uniform vec4 u_ParallaxParams;

uniform vec4 u_AmbientColor;
uniform vec4 u_DiffuseColor;
uniform vec4 u_SpecularColor;

// XYZW: transparency, reflectivity, shine strength, bump mapping
uniform vec4 u_MaterialParams;

// X: alpha test value
uniform vec4 u_MaterialAlphaTest;

// XYZW: shading model, reflectivity eta, roughness U, roughness V
uniform vec4 u_MaterialShading;

uniform mat4 in_ShadowMatrix[4];
