/*VERTEX_PROGRAM*/

#include Layout.sp

in vec4 in_Vertex;
in vec4 in_TexCoord;
in vec3 in_Normal;
in vec2 in_Bones;

out vec3 v_CubeCoord;
out float v_ClipDistance;

uniform vec4 u_ClipPlane;

void main()
{
   gl_Position = in_ModelViewProjectionMatrix * in_Vertex;

   v_CubeCoord = in_Vertex.xzy;

	v_ClipDistance = dot( u_ClipPlane, in_ModelMatrix * in_Vertex );
}

/*FRAGMENT_PROGRAM*/

#include Layout.sp

uniform samplerCube Texture0;

in vec3 v_CubeCoord;
in float v_ClipDistance;

out vec4 out_FragColor;

void main()
{
	if ( v_ClipDistance < 0.0 ) discard;

   vec4 Sky = texture( Texture0, v_CubeCoord );

   out_FragColor = 0.1 * Sky;
}
