/*VERTEX_PROGRAM*/

#include Layout.sp

in vec4 in_Vertex;
in vec4 in_TexCoord;

out vec2 TexCoord;

void main()
{
	gl_Position = in_ModelViewProjectionMatrix * in_Vertex;

	TexCoord = vec2( in_TexCoord.x, 1.0 - in_TexCoord.y );
}

/*FRAGMENT_PROGRAM*/

in vec2 TexCoord;

uniform sampler2D Texture0;
uniform sampler2D Texture1;

uniform float b_Muted;

out vec4 out_FragColor;

bool ContainsPoint( vec2 Point, vec4 Rect )
{
	return Point.x >= Rect.x && Point.y >= Rect.y && Point.x <= Rect.z && Point.y <= Rect.w;
}

void main()
{
	const vec4 Muted = vec4( 0.0,  0.0,  0.1, 0.1 );

	vec4 Color     = texture( Texture0, TexCoord );
	vec4 ColorMute = texture( Texture1, TexCoord * vec2( 8.0, 8.0 ) );

	if ( b_Muted  > 0.5 && ContainsPoint( TexCoord.xy, Muted ) ) Color = ColorMute;

   out_FragColor = vec4( Color.xyz, 1.0 );
}
